<template>
	<table>
		<thead>
			<tr>
				<th class="favorite-head" @click="onOrderFiles('favorite')">
					{{ t('sorts', 'Favorite') }}
				</th>
				<th class="name-head" @click="onOrderFiles('name')">
					{{ t('sorts', 'Name') }}
				</th>
				<th class="tags-head" @click="onOrderFiles('systemtags')">
					{{ t('sorts', 'Tags') }}
				</th>
				<th class="external-head" />
				<th @click="onOrderFiles('share')">
					{{ t('sorts', 'Share') }}
				</th>
				<th class="share-head" @click="onOrderFiles('size')">
					{{ t('sorts', 'Size') }}
				</th>
				<th class="modified-head" @click="onOrderFiles('mtime')">
					{{ t('sorts', 'Modified') }}
				</th>
			</tr>
		</thead>
		<tbody>
			<tr v-for="node in nodesList" :key="node.id">
				<td class="favorite-field">
					<img width="16"
						height="16"
						:src="node.tags[0] === '_$!<Favorite>!$_' ? starredImgPath : starOutlineImgPath"
						:alt="node.tags[0] === '_$!<Favorite>!$_' ? 'favorite' : 'not favorite'">
				</td>
				<td class="name-field"
					:class="{ folder: node.mimetype === 'httpd/unix-directory' }"
					:style="indentDepth(node.depth)"
					@click="onClick(node)">
					<img :src="mimeIcon(node.mimetype)" :alt="node.mimetype">
					{{ node.nodeName }}
					<span v-if="node.depth === 0 && isFilter"> {{ stripFilename(node.path) }}</span>
				</td>
				<td class="tags-field">
					<span v-for="(tag, index) in node.systemTags" :key="index" class="tag">
						{{ tag }}
					</span>
				</td>
				<td class="external-field">
					<a :href="getFileLink(node.id)" :title="t('sorts', 'Go to the file')">
						<img :src="externalImgPath" alt="">
					</a>
				</td>
				<td class="share-field">
					{{ node.isShared }}
				</td>
				<td class="size-field">
					{{ formatSize(node.size) }}
				</td>
				<td class="modified-field">
					{{ formatDate(node.mtime) }}
				</td>
			</tr>
		</tbody>
	</table>
</template>

<script>
import '@nextcloud/dialogs/styles/toast.scss'
import { imagePath, getRootUrl } from '@nextcloud/router'
import moment from '@nextcloud/moment'
import { formatFileSize } from '@nextcloud/files'

export default {
	name: 'NodesList',
	props: {
		nodesTree: {
			type: Array,
			default: () => null,
		},
		isFilter: {
			type: Boolean,
		},
	},
	data() {
		return {
			timer: null,
			clicks: 0,
			externalImgPath: imagePath('sorts', 'external.svg'),
			starOutlineImgPath: imagePath('sorts', 'star-outline.svg'),
			starredImgPath: imagePath('sorts', 'starred.svg'),
		}
	},
	computed: {
		/**
		 * Return the plane array of nodes, with depth properties on each nodes
		 *
		 * @return {object|null}
		 */
		nodesList() {
			if (this.nodesTree === null) {
				return null
			}
			const result = []
			const func = function(nodes, depth) {
				nodes.forEach((node) => {
					node.depth = depth
					result.push(node)
					if (Array.isArray(node.nodes)) {
						func(node.nodes, depth + 1)
					}
				})
			}

			func(this.nodesTree, 0)
			return result
		},
		sortAttribute() {
			const res = this.$route.query.sortAttribute
			return typeof res === 'undefined' ? 'name' : res
		},
		sortDescending() {
			const res = this.$route.query.sortDescending
			return typeof res === 'undefined' ? false : res
		},
	},

	methods: {

		/**
		 * Differentiate between simple and double click
		 *
		 * @param {object} node Node object
		 */
		onClick(node) {
			this.clicks++
			if (this.clicks === 1) {
				this.timer = setTimeout(() => {
					this.clicks = 0
					this.$emit('toggle-directory', node.path)
				}, 200) // tolerance in ms
			} else {
				this.clicks = 0
				clearTimeout(this.timer)
				if (node.type === 'dir') {
					this.$emit('enter-directory', node.path)
				}
			}
		},

		/**
		 * Format a Unix timestamp into a readable date
		 *
		 * @param {number} time Unix timestamp (in second since the Epoch)
		 * @return {string}
		 */
		formatDate(time) {
			return moment(time, 'X').fromNow()
		},

		/**
		 * Format a size in Byte into a human readable size
		 *
		 * @param {number} size File's size in byte
		 * @return {string}
		 */
		formatSize(size) {
			return formatFileSize(size)
		},

		/**
		 * Strip the path from trailing filename
		 *
		 * @param {string} path Path to node
		 * @return {string}
		 */
		stripFilename(path) {
			return path.replace(/\/[^/]*$/, '')
		},

		/**
		 * Return a thumbnail url for given MimeType
		 *
		 * @param {string} mime File's mimetype
		 * @return {string}
		 */
		mimeIcon(mime) {
			return OC.MimeType.getIconUrl(mime)
		},

		/**
		 * Get the url to open given node in 'Files'
		 *
		 * @param {number} nodeId Node's id
		 * @return {string}
		 */
		getFileLink(nodeId) {
			return getRootUrl() + '/index.php/f/' + nodeId
		},

		/**
		 * Add a css padding depending of the depth of nested node
		 *
		 * @param {number} depth Depth of the nested node (file | folder)
		 * @return {object}
		 */
		indentDepth(depth) {
			return {
				paddingLeft: `calc(10px + ${depth}em)`,
			}
		},

		/**
		 * Change the sortAttribute and sortDescending get parameters in URL
		 *
		 * @param {string} newSortAttribute Triggered attribute
		 */
		onOrderFiles(newSortAttribute) {
			if (newSortAttribute === this.sortAttribute) {
				this.$router.push({
					name: this.$route.name,
					query: { ...this.$route.query, sortDescending: !this.sortDescending },
				})
			} else {
				this.$router.push({
					name: this.$route.name,
					query: { ...this.$route.query, sortAttribute: newSortAttribute, sortDescending: false },
				})
			}
		},

	},
}
</script>
<style scoped>
table {
	display: block;
	width: calc(100% - 8px);
	overflow-x: auto;
}

td {
	line-height: 40px;
}

td, th {
	padding: 0 1rem;
}

td.favorite-field {
	text-align: center;
}

td.name-field.folder {
	cursor: pointer;
}

.tag {
	background: grey;
	margin-left: .2em;
	margin-right: .2em;
	padding-left: .4em;
	padding-right: .4em;
	border-radius: 1em;
}
</style>
